package ping

import (
	"github.com/iotaledger/goshimmer/plugins/autopeering/protocol/constants"
	"github.com/iotaledger/goshimmer/plugins/autopeering/types/peer"
)

const (
	MARSHALLED_PACKET_HEADER = 0x04

	PACKET_HEADER_START        = 0
	MARSHALLED_ISSUER_START    = PACKET_HEADER_END
	MARSHALLED_PEERS_START     = MARSHALLED_ISSUER_END
	MARSHALLED_SIGNATURE_START = MARSHALLED_PEERS_END

	PACKET_HEADER_END        = PACKET_HEADER_START + PACKET_HEADER_SIZE
	MARSHALLED_ISSUER_END    = MARSHALLED_ISSUER_START + MARSHALLED_ISSUER_SIZE
	MARSHALLED_PEERS_END     = MARSHALLED_PEERS_START + MARSHALLED_PEERS_SIZE
	MARSHALLED_SIGNATURE_END = MARSHALLED_SIGNATURE_START + MARSHALLED_SIGNATURE_SIZE

	PACKET_HEADER_SIZE              = 1
	MARSHALLED_ISSUER_SIZE          = peer.MARSHALLED_TOTAL_SIZE
	MARSHALLED_PEER_ENTRY_FLAG_SIZE = 1
	MARSHALLED_PEER_ENTRY_SIZE      = MARSHALLED_PEER_ENTRY_FLAG_SIZE + peer.MARSHALLED_TOTAL_SIZE
	MARSHALLED_PEERS_SIZE           = MARSHALLED_PEER_ENTRY_SIZE * constants.NEIGHBOR_COUNT
	MARSHALLED_SIGNATURE_SIZE       = 65

	MARSHALLED_TOTAL_SIZE = MARSHALLED_SIGNATURE_END
)
